/***************************************************

  hexrev.c : Zpo[VQ[

    Copyright (C) 1997 - 2000 by Makoto Hiroi


-CRX ver dc_shoryu 2000

****************************************************/
#include	"hexrev.h"

int		first_move = TRUE;		/* lԑij */
int		level = 1;				/* x */
int		play_flag;				/* Q[ */

int		C_RES_FREETURN=46;		/*U[u^[*/
int		C_RES_WHO=BLACK;		/*܂ς̗\*/


/* 250 msec wait [` */
void wait( void )
{
	int		start = clock();
	while( (clock() - start) < 25 );
}

/* I */
volatile void quit( void )
{
	_iocs_crtmod( 16 );
	_iocs_skey_mod( -1, 0, 0 );	/* \tgEFAL[{[h */
	_iocs_ms_curof();
	_dos_c_fnkmod( 0 );
	_dos_c_curon();
	_dos_c_window( 0, 31 );
	exit( 0 );
}

/* bZ[W */
typedef enum {
	MOVE_COM, MOVE_HUMAN, BREAK, C_WIN, H_WIN, DRAW, THINK, PASS_M, NOT_PUT,
} MES_CODE;

const char *mes_table[] = {
	"킽̎Ԃł",
	"Ȃ̎Ԃł",
	"΋ǂ𒆒f܂",
	"̏ł@@",
	"Ȃ̏ł",
	"łˁ@",
	"lĂ܂EE",
	"EEpXłEE",
	"΂͒u܂",
};

/* bZ[Wo */
static void print_mes( int pos )
{
	_dos_c_locate( 22, 28 );
	printf( "%s", mes_table[pos] );
	fflush( stdout );
	wait();
	wait();
}

/* ΂u */
static int put_piece( int num, int piece )
{
  char buffer[SIZE];
  char *ptr = buffer;
  int c = reverse_piece( num, piece, buffer );
  if( c > 0 ){
    draw_piece( num, piece );
    wait();
    while( *ptr != -1 ){
      draw_piece( *ptr++, piece );
      wait();
    }
  }
  return c;
}

/* }EX */
static int input_mouse( int piece )
{
  for(;;){
    int		pos, x, y;
    while( _iocs_ms_ontm( 0, 0 ) == 0 );	/* {^܂ő҂ */
    pos = _iocs_ms_curgt();
    while( _iocs_ms_offtm( 0, 0 ) == 0 );	/* {^̂҂ */
    x = pos >> 16; y = pos & 0xffff;
    if( (piece < FREE) &&
        (x >= 48 && x < 466) && (y >= 48 && y < 466) ){
      /* u */
      int n = get_postion( x, y );
      if( n == -1 || put_piece( n, piece ) <= 0 ){
        /* ̏ꏊɂ͒u܂ */
        print_mes( NOT_PUT );
      } else {
        return n;
      }
    } else if( y >= 480 ){  /* Xe[^XC */
      x = x / 64;
      switch( x - 4 ){
      case 0:		/* x̕ύX */
        if( ++level > 5 ) level = 1;
        print_level();
        break;
      case 1:		/* E̕ύX */
        if( play_flag == FALSE ){
          first_move = (first_move ? FALSE : TRUE);
          print_move();
        }
        break;
      case 2:		/* ΋ */
        return START;
      case 3:		/* I */
        quit(); break;
      }
    }
  }
}


/* Q[̎s */
static void play( void )
{
  int	turn, move, human_piece, com_piece, value;
  C_RES_FREETURN=(rand()%((SIZE-6)/2))+6;	/*^C~O̐ݒFO܂Ԃ܂łɔ*/
  C_RES_WHO=((rand()%100)>=50)?BLACK:WHITE;	/**/
  if( first_move ){
    turn = HUMAN;
    human_piece = BLACK; com_piece = WHITE;
  } else {
    turn = COM;
    human_piece = WHITE; com_piece = BLACK;
  }
  for(;;){
    if( getTurnNum()==C_RES_FREETURN ){	/**/
        setBoard(45,C_RES_WHO);
        draw_piece( 45, C_RES_WHO );
    }					/**/
    if( turn == HUMAN ){
      /* lԑ̎w */
      print_mes( MOVE_HUMAN );
      if( !check_move( human_piece ) ){
        if( check_move( com_piece ) ){
          /* pXł */
          print_mes( PASS_M );
        } else {
          /* Ił */
          value = result_value( TRUE );
          break;
        }
      } else {
        if( (move = input_mouse( human_piece )) == START ){
          /* fł */
          print_mes( BREAK );
          value = NO_VALUE;
          break;
        }
      }
      turn = COM;

#ifdef 0
      if( (move = select_move( human_piece, level )) == PASS ){
        if( check_move( com_piece ) ){
          /* pX */
          print_mes( PASS_M );
        } else {
          /* Ił */
          value = result_value( TRUE );
          break;
        }
      } else {
        put_piece( move, human_piece );  /* u */
      }
      turn = COM;
#endif

    } else {
      /* Rs[^̎w */
      print_mes( MOVE_COM );
      if( (move = select_move( com_piece, level )) == PASS ){
        if( check_move( human_piece ) ){
          /* pX */
          print_mes( PASS_M );
        } else {
          /* Ił */
          value = result_value( TRUE );
          break;
        }
      } else {
        put_piece( move, com_piece );	/* u */
      }
      turn = HUMAN;
    }
    print_stones();
    /* I */
    if( (value = result_value( FALSE )) != NO_VALUE ){
      break;		/* Ił */
    }
  }
  if( value != NO_VALUE ){
    if( value == 0 ){
      print_mes( DRAW );
    } else if( value > 0 ){
      /* ̏ */
      print_mes( (human_piece == BLACK ? H_WIN : C_WIN) );
    } else {
      /* ̏ */
      print_mes( (human_piece == WHITE ? H_WIN : C_WIN) );
    }
  }
}

/*  */
static void init_rev( void )
{
	srand( time( NULL ) );	/* ̏ */
	init_screen();			/* ʂ̏ */
	init_data();			/* f[^̏ */
	_dos_c_cls_al();
}


/* C[` */
int main( int argc, char *argv[] )
{
	init_rev();
	for(;;){
		/* ΋ǂ܂ő҂ */
		while( input_mouse( FREE ) != START );
		init_data();
		play_flag = TRUE;
		play();					/* Q[̎s */
		play_flag = FALSE;
	}
	/* I quit ōs */
	return 0;
}

/* end of file */

